--[[
Copyright (C) Achimobil

Author: Achimobil
Date: 03.09.2022
Version: 0.1.0.0

Contact:
https://discord.gg/Va7JNnEkcW

History:
V 0.1.0.0 @ 03.08.2022 - First Version.

Important:
Free for use in other mods - no permission needed, only provide my name.
No changes are to be made to this script without permission from Achimobil.

Frei verwendbar - keine erlaubnis nötig, Namensnennung im Mod erforderlich.
An diesem Skript dürfen ohne Genehmigung von Achimobil keine Änderungen vorgenommen werden.
]]

AnimationOnSiloFillLevelChangeSpecialization = {
    Version = "0.1.0.0",
    Name = "AnimationOnSiloFillLevelChangeSpecialization"
}
print(g_currentModName .. " - init " .. AnimationOnSiloFillLevelChangeSpecialization.Name .. "(Version: " .. AnimationOnSiloFillLevelChangeSpecialization.Version .. ")");

function AnimationOnSiloFillLevelChangeSpecialization.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(PlaceableSilo, specializations);
end

function AnimationOnSiloFillLevelChangeSpecialization.registerFunctions(placeableType)
	SpecializationUtil.registerFunction(placeableType, "startAnimationForSiloFillLevelChange", AnimationOnSiloFillLevelChangeSpecialization.startAnimationForSiloFillLevelChange);
end

function AnimationOnSiloFillLevelChangeSpecialization.registerEventListeners(placeableType)
	SpecializationUtil.registerEventListener(placeableType, "onLoad", AnimationOnSiloFillLevelChangeSpecialization);
	SpecializationUtil.registerEventListener(placeableType, "onFinalizePlacement", AnimationOnSiloFillLevelChangeSpecialization);
end

function AnimationOnSiloFillLevelChangeSpecialization:onLoad(savegame)
    
	function self.fillLevelChangedCallback(fillType, delta)
        self:startAnimationForSiloFillLevelChange();
	end   
end

function AnimationOnSiloFillLevelChangeSpecialization:onFinalizePlacement(savegame)
	for _, sourceStorage in pairs(self.spec_silo.loadingStation:getSourceStorages()) do
        sourceStorage:addFillLevelChangedListeners(self.fillLevelChangedCallback);
    end
end

function AnimationOnSiloFillLevelChangeSpecialization:startAnimationForSiloFillLevelChange()

    -- animation aufrufen, wenn diese methode aufgerufen wird
    local animatedSpec = self.spec_animatedObjects;
    for _, animatedObject in ipairs(animatedSpec.animatedObjects) do
        if animatedObject.saveId == "aufzug" then
            if animatedObject.animation.time == 0 or animatedObject.animation.time == 1 then
                local direction = animatedObject.animation.direction * -1
                animatedObject:setDirection(direction)
            end
        end
    end
end